import * as events from '@aws-cdk/aws-events';
import * as iam from '@aws-cdk/aws-iam';
import { Construct } from '@aws-cdk/core';
import * as codepipeline from '../lib';
export interface FakeBuildActionProps extends codepipeline.CommonActionProps {
    input: codepipeline.Artifact;
    output?: codepipeline.Artifact;
    extraInputs?: codepipeline.Artifact[];
    owner?: string;
    role?: iam.IRole;
    account?: string;
    region?: string;
    customConfigKey?: string;
}
export declare class FakeBuildAction implements codepipeline.IAction {
    readonly actionProperties: codepipeline.ActionProperties;
    private readonly customConfigKey;
    constructor(props: FakeBuildActionProps);
    bind(_scope: Construct, _stage: codepipeline.IStage, _options: codepipeline.ActionBindOptions): codepipeline.ActionConfig;
    onStateChange(_name: string, _target?: events.IRuleTarget, _options?: events.RuleProps): events.Rule;
}
