import * as events from '@aws-cdk/aws-events';
import { Construct } from '@aws-cdk/core';
import * as codepipeline from '../lib';
export interface IFakeSourceActionVariables {
    readonly firstVariable: string;
}
export interface FakeSourceActionProps extends codepipeline.CommonActionProps {
    readonly output: codepipeline.Artifact;
    readonly extraOutputs?: codepipeline.Artifact[];
    readonly region?: string;
}
export declare class FakeSourceAction implements codepipeline.IAction {
    readonly inputs?: codepipeline.Artifact[];
    readonly outputs?: codepipeline.Artifact[];
    readonly variables: IFakeSourceActionVariables;
    readonly actionProperties: codepipeline.ActionProperties;
    constructor(props: FakeSourceActionProps);
    bind(_scope: Construct, _stage: codepipeline.IStage, _options: codepipeline.ActionBindOptions): codepipeline.ActionConfig;
    onStateChange(_name: string, _target?: events.IRuleTarget, _options?: events.RuleProps): events.Rule;
}
